# print_string_x86.s

# Syscalls
.equ SYSCALL_EXIT,     1
.equ SYSCALL_WRITE,    4

# Other definitions
.equ STDOUT,	       1

        .globl _start
_start:

	xor	%eax,%eax	# Clear eax to 0

	# Your Code Here

	call	print_number
	mov	$linefeed,%eax
	call	print_string

	# Your Code Also Here

        #================================
        # Exit
        #================================
exit:
	mov	$5,%ebx
        mov     $SYSCALL_EXIT,%eax	# put exit syscall number (1) in eax
        int     $0x80			# and exit


	#====================
	# print string
	#====================
	# Null-terminated string to print pointed to by %eax
	# %eax is trashed by this routine

print_string:
	push	%ebx	# Save registers on stack
	push	%ecx
	push	%edx
	push	%esi

	mov	%eax,%ecx		# String to print is arg3 (%ecx)
	mov	$SYSCALL_WRITE,%eax	# Syscall number goes in %eax
	mov	$STDOUT,%ebx		# Destination fd is arg1 (%ebx)

	# Now we need the length in %edx
	xor	%edx,%edx		# Set %edx to 0
	mov	%ecx,%esi
count_loop:
	cmpb	$0,(%esi)
	je	zero			# If zero, we are done

	inc	%edx			# Otherwise increase length count
	inc	%esi			# increment pointer

	jmp	count_loop		# And continue in loop

zero:	# Found Zero, we are done

	int	$0x80			# Print the string

	pop	%esi	# Restore registers from stack
	pop	%edx	# In reverse order as we saved, stack is LIFO
	pop	%ecx
	pop	%ebx

	ret				# Return to where we came from


        ##############################
	# print_number
	##############################
	# eax = value to print
	# eax is destroyed by this routine

print_number:
	push	%ebx
	push	%ecx
	push	%edx
	push	%edi

	mov	$10,%ebx
	xor     %ecx,%ecx
	mov	$buffer,%edi
div_by_10:
	xor	%edx,%edx
	div     %ebx		# Stores Quotient in eax, remainder in edx
	push    %edx
	inc     %ecx
	or      %eax,%eax
	jnz     div_by_10
write_out:
	pop     %eax
	add     $0x30, %al
	stosb			# Stores %al to address %edi
				# and increments %edi

	loop    write_out	# decrements %ecx and jumps if not 0

	pop	%edi
	pop	%edx
	pop	%ecx
	pop	%ebx

	mov	$buffer,%eax
	call	print_string

        ret

.data
linefeed: .string "\n"
.lcomm buffer,11
